Reality Modeling
Download API definition:
POST https://api.bentley.com/reality-modeling/jobs

Create a new job.

Authentication

Requires Authorization header with valid Bearer token for scope itwin-platform.

For more documentation on authorization and how to get access token visit OAUTH2 Authorization page.

Request headers

Name
Required?
Description
Authorization
Yes

OAuth access token with itwin-platform scope

Accept
Yes

Setting to application/vnd.bentley.itwin-platform.v2+json is recommended.

Request body

Job Creation

Example

json
{
    "specifications": {
        "inputs": {
            "scene": "7e8bd05b-f82f-4955-81e9-7d66a731857a"
        },
        "outputs": {
            "exports": [{
                "format": "3DTiles"
            }, {
                "format": "OBJ"
            }],
            "modelingReference": true
        }
    },
    "name": "My first Reality Modeling job",
    "type": "Reconstruction",
    "iTwinId": "3fa85f64-5717-4562-b3fc-2c963f66afa6"
}

Response 201 Created

Created

json
{
    "job": {
        "id": "796715aa-bc5a-4df5-9554-ceed038babc6",
        "state": "Active",
        "userId": "911edf8b-59ad-404c-a743-aec05ca038e9",
        "executionInfo": {
            "createdDateTime": "2025-03-10T11:30:00Z"
        },
        "specifications": {
            "inputs": {
                "scene": "7e8bd05b-f82f-4955-81e9-7d66a731857a"
            },
            "outputs": {
                "modelingReference": {
                    "location": "1aee1cb3-d0cc-4bb3-a261-fdc17b598464"
                },
                "exports": [{
                    "location": "9d9da8fa-0b26-4eaa-b297-b22c2bb8e1d1",
                    "format": "3DTiles"
                }, {
                    "location": "8359a84c-8bd0-4af9-9403-d5f78d8e37e8",
                    "format": "OBJ"
                }]
            }
        },
        "name": "My first Reality Modeling job",
        "type": "Reconstruction",
        "iTwinId": "3fa85f64-5717-4562-b3fc-2c963f66afa6"
    }
}

Response 400 Bad Request

The 400 status code indicates that the request cannot be processed by the server due to a client error (e.g. malformed request syntax).

json
{
    "error": {
        "code": "InvalidRealityModelingRequest",
        "message": "Invalid request to Reality Modeling.",
        "details": [{
            "code": "InvalidProperty",
            "message": "Invalid value 'FillImageProperties1' for property 'type', line 15, position 34.",
            "target": "type"
        }]
    }
}

Response 401 Unauthorized

This response indicates that request lacks valid authentication credentials. Access token might not been provided, issued by the wrong issuer, does not have required scopes or request headers were malformed.

json
{
    "error": {
        "code": "HeaderNotFound",
        "message": "Header Authorization was not found in the request. Access denied."
    }
}

Response 429 Too many requests

This response indicates that the client sent more requests than allowed by this API for the current tier of the client.

json
{
    "error": {
        "code": "RateLimitExceeded",
        "message": "The client sent more requests than allowed by this API for the current tier of the client."
    }
}

Response headers

Name
Description
retry-after

Number of seconds to wait until client is allowed to make more requests.

Error

Contains error information.

Name
Type
Description
code
String

One of a server-defined set of error codes.

message
String

A human-readable representation of the error.

target
String, null

The target of the error.

Error Response

Gives details for an error that occurred while handling the request. Note that clients MUST NOT assume that every failed request will produce an object of this schema, or that all of the properties in the response will be non-null, as the error may have prevented this response from being constructed.

Name
Type
Description
error

DetailedError

Contains error information and an array of more specific errors.

Name
Type
Description
code
String

One of a server-defined set of error codes.

message
String

A human-readable representation of the error.

target
String, null

The target of the error.

details

Optional array of more specific errors.

Detailed Error Response

Gives details for an error that occurred while handling the request. Note that clients MUST NOT assume that every failed request will produce an object of this schema, or that all of the properties in the response will be non-null, as the error may have prevented this response from being constructed.

Name
Type
Description

Job state

Job current state

Name
Type
Description
Queued
String
Active
String
TerminatingOnCancel
String
TerminatingOnFailure
String
Cancelled
String
Failed
String
Success
String

Execution Information

Execution information relative to a job.

Name
Type
Description
startedDateTime
Date-time, null

Start time of the job.

endedDateTime
Date-time, null

End time of the job.

createdDateTime
Date-time

Creation time of the job.

processingUnits
Number, null

The number of processing units consumed by the job.

FillImageProperties Inputs

List of possible inputs for a Fill Image Properties job.

Name
Type
Description
imageCollections
String[], null

List of image collection reality data ids.

sceneToProcess
String, null

Reality data id of ContextScene to process.

sceneToComplete
String, null

Reality data id of ContextScene to complete.

presets
String[], null

List of paths to preset.

FillImageProperties Outputs

List of possible outputs for a Fill Image Properties job.

Name
Type
Description
scene
String

Output reality data id of ContextScene with image properties filled.

Altitude Reference

Values for Altitude Reference when filling image properties.

Name
Type
Description
SeaLevel
String
WGS84Ellipsoid
String

FillImageProperties Options

List of possible options for Fill Image Properties job.

Name
Type
Description
recursiveImageCollections
Boolean, null

Recursively read folders in image collection.

altitudeReference

FillImageProperties Specifications

Specifications for Fill Image Properties job.

ImportPointCloud Inputs

Name
Type
Description
scene
String

Reality data id of ContextScene to process

crsData
String, null

Path in the bucket for CRS Data

ImportPointCloud Outputs

Name
Type
Description
scanCollection
String

Output reality data id for scan collection

scene
String, null

Output reality data id for context scene referencing scan collection

ImportPointCloud Specifications

Name
Type
Description

Calibration Inputs

Name
Type
Description
scene
String

Reality data ID of ContextScene to process

crsData
String, null

Path in the bucket for CRS Data

presets
String[], null

List of paths to preset

Calibration Outputs

Name
Type
Description
scene
String

Reality data ID of calibrated ContextScene

report
String, null

Path in the bucket of Calibration report

texturedTiePoints
String, null

Reality data ID of textured tie points

Rig Synchro

Name
Type
Description
None
String
Strict
String
Loose
String

Rotation Policy

Name
Type
Description
Compute
String
Adjust
String
Keep
String
Extend
String

Center Policy

Name
Type
Description
Compute
String
Adjust
String
AdjustWithinTolerance
String
Keep
String
Extend
String

Focal Policy

Name
Type
Description
Adjust
String
Keep
String

Principal Policy

Name
Type
Description
Adjust
String
Keep
String

Radial Policy

Name
Type
Description
Adjust
String
Keep
String

Tangential Policy

Name
Type
Description
Adjust
String
Keep
String

Fisheye Focal Policy

Name
Type
Description
AdjustSymmetric
String
AdjustAsymmetric
String
Keep
String

Fisheye Distortion Policy

Name
Type
Description
Adjust_01xx0
String
Adjust_x1xx0
String
Adjust_x1xxx
String
Keep
String

Aspect Ratio Policy

Name
Type
Description
Adjust
String
Keep
String

Skew Policy

Name
Type
Description
Adjust
String
Keep
String

Tiepoints Policy

Name
Type
Description
Compute
String
Keep
String

Pair Selection

Name
Type
Description
Default
String
Sequence
String
Loop
String
Exhaustive
String
SimilarOnly
String

Keypoints Density

Name
Type
Description
Normal
String
High
String

Tag

Name
Type
Description
QR
String
April
String
Chili
String
Checkerboards
String

Color Equalization

Name
Type
Description
None
String
BlockWise
String
MachineLearning
String

Adjustment Constraints

Name
Type
Description
None
String
ControlPoints
String
PositionMetadata
String
PointClouds
String
Automatic
String

Rigid Registration Position

Name
Type
Description
None
String
UserConstraints
String
ControlPoints
String
PositionMetadata
String
PointClouds
String
Automatic
String

Rigid Registration Rotation

Name
Type
Description
None
String
UserConstraints
String
ControlPoints
String
PositionMetadata
String
PointClouds
String
Automatic
String
RotationMetadata
String

Rigid Registration Scale

Name
Type
Description
None
String
UserConstraints
String
ControlPoints
String
PositionMetadata
String
PointClouds
String
Automatic
String

Calibration Options

Name
Type
Description
rigSynchro
rotationPolicy
centerPolicy
centerTolerance
Number, null

Center tolerance, use only when center policy is AdjustWithinTolerance

focalPolicy
principalPolicy
radialPolicy
tangentialPolicy
fisheyeFocalPolicy
fisheyeDistortionPolicy
aspectRatioPolicy
skewPolicy
tiepointsPolicy
pairSelection
pairSelectionDistance
Integer, null

Pair selection distance, use only when pair selection mode is Sequence or Loop

keypointsDensity
precalibration
Boolean, null

Enable precalibration

tagsExtraction
Tag[], null

Tags to extract

colorEqualization
adjustmentConstraints

Adjustment constraints

rigidRegistrationPosition
rigidRegistrationRotation
rigidRegistrationScale
sceneOutputCrs
String, null

CRS to use when producing the output ContextScene

Calibration Specifications

Name
Type
Description

Tiling Inputs

Name
Type
Description
scene
String

Reality data id of ContextScene to process

regionOfInterest
String, null

Path in the bucket to region of interest file

crsData
String, null

Path in the bucket for CRS Data

presets
String[], null

List of paths to preset

Modeling Reference

Name
Type
Description
location
String

Reality data id of Modeling Reference

Tiling Outputs

Name
Type
Description
modelingReference

Modeling Reference Type

Name
Type
Description
Orthophoto
String
Complete
String

TilingMode

Name
Type
Description
NoTiling
String
RegularPlanarGrid
String
RegularVolumetricGrid
String
Adaptive
String

Point3d

Name
Type
Description
x
Number

X coordinate

y
Number

Y coordinate

z
Number

Z coordinate

Geometric Precision

Name
Type
Description
Medium
String
High
String
Extra
String
Ultra
String

Tiling Pair Selection

Name
Type
Description
Generic
String
StructuredAerial
String
RegionOfInterest
String

Photo Used For Geometry

Name
Type
Description
ExcludeThermal
String
IncludeThermal
String
None
String

Hole Filling

Name
Type
Description
SmallHoles
String
AllHoles
String

Simplification

Name
Type
Description
Standard
String
PlanarRelative
String
PlanarAbsolute
String

PointCloud Color Source

Name
Type
Description
None
String
Color
String
Intensity
String
ScaledIntensity
String

Color Correction

Name
Type
Description
None
String
Standard
String
StandardWithThermal
String
BlockWise
String
BlockWiseWithThermal
String

Untextured Representation

Name
Type
Description
InpaintingCompletion
String
UniformColor
String

Texture Source

Name
Type
Description
PhotosFirst
String
PointCloudsFirst
String
Smart
String

Tiling Options

Name
Type
Description
modelingReferenceType
tilingMode
tilingValue
Number, null

Tiling Value

tilingOrigin
discardEmptyTiles
Boolean, null

Discard emtpy tiles

crs
String, null

Coordinate Reference System

geometricPrecision
pairSelection
photoUsedForGeometry
holeFilling
simplification
planarSimplificationTolerance
Number, null

Planar simplification tolerance

pointCloudColorSource
colorCorrection
untexturedRepresentation
untexturedColor
String, null

Untextured color

textureSource
orthoResolution
Number, null

Ortho resolution

geometryResolutionLimit
Number, null

Geometry resolution limit

textureResolutionLimit
Number, null

Texture resolution limit

Tiling Specifications

Name
Type
Description

Production Inputs

Name
Type
Description
scene
String

Reality data id of ContextScene to process

modelingReference
String

Reality data id of modeling reference to process

extent
String, null

Path in the bucket to region of interest file, used for export extent

crsData
String, null

Path in the bucket for CRS Data

presets
String[], null

List of paths to preset

Format

Name
Type
Description
3DTiles
String
3MX
String
OBJ
String
LAS
String
PLY
String
OPC
String
OrthophotoDSM
String
I3S
String
OSGB
String

Color Source

Name
Type
Description
None
String
Visible
String
Thermal
String
Resolution
String

Thermal Unit

Name
Type
Description
Absolute
String
Celsius
String
Fahrenheit
String

LOD Scope

Name
Type
Description
TileWise
String
AcrossTiles
String

Cesium Compression

Name
Type
Description
None
String
Draco
String

Options 3DTiles

Name
Type
Description
textureColorSource
textureColorSourceResMin
Number, null

Minimum resolution for the texture color source

textureColorSourceResMax
Number, null

Maximum resolution for the texture color source

textureColorSourceThermalUnit
textureColorSourceThermalMin
Number, null

Minimum thermal value for the texture color source

textureColorSourceThermalMax
Number, null

Maximum thermal value for the texture color source

crs
String, null

Coordinate Reference System

lodScope

Options 3MX

Name
Type
Description
textureColorSource
textureColorSourceResMin
Number, null

Minimum resolution for the texture color source

textureColorSourceResMax
Number, null

Maximum resolution for the texture color source

textureColorSourceThermalUnit
textureColorSourceThermalMin
Number, null

Minimum thermal value for the texture color source

textureColorSourceThermalMax
Number, null

Maximum thermal value for the texture color source

crs
String, null

Coordinate Reference System

crsOrigin
lodScope
generateWebApp
Boolean, null

Flag to generate a web application

LOD Type

Name
Type
Description
None
String
Unary
String
Quadtree
String
Octree
String
Adaptive
String
BingMaps
String

Options OBJ

Name
Type
Description
textureColorSource
textureColorSourceResMin
Number, null

Minimum resolution for the texture color source

textureColorSourceResMax
Number, null

Maximum resolution for the texture color source

textureColorSourceThermalUnit
textureColorSourceThermalMin
Number, null

Minimum thermal value for the texture color source

textureColorSourceThermalMax
Number, null

Maximum thermal value for the texture color source

maximumTextureSize
Integer, null

Maximum texture size

textureCompression
Integer, null

JPG compression of texture file

textureSharpening
Boolean, null

Enable or disable texture sharpening.

lodScope
lodType
crs
String, null

Coordinate Reference System

crsOrigin
doublePrecision
Boolean, null

Flag for double precision

Sampling Strategy

Name
Type
Description
Resolution
String
Absolute
String

Las Compression

Name
Type
Description
None
String
LAZ
String

Options LAS

Name
Type
Description
crs
String, null

Coordinate Reference System

samplingStrategy
samplingDistance
Number, null

Sampling distance

mergePointClouds
Boolean, null

Flag to merge point clouds

textureColorSource

Options PLY

Name
Type
Description
crs
String, null

Coordinate Reference System

samplingStrategy
samplingDistance
Number, null

Sampling distance

mergePointClouds
Boolean, null

Flag to merge point clouds

includeNormals
Boolean, null

Flag to include normals

textureColorSource

Options OPC

Name
Type
Description
crs
String, null

Coordinate Reference System

samplingStrategy
samplingDistance
Number, null

Sampling distance

textureColorSource

Projection Mode

Name
Type
Description
HighestPoint
String
LowestPoint
String

Ortho Format

Name
Type
Description
GeoTIFF
String
JPEG
String
None
String

Ortho Color Source

Name
Type
Description
Reference3dModelVisible
String
OptimizedComputationVisible
String
Reference3dModelThermal
String
OptimizedComputationThermal
String

DSM Format

Name
Type
Description
GeoTIFF
String
ASC
String
None
String

Overview Type

Name
Type
Description
None
String
Embedded
String
OvrFile
String

Options OrthoDSM

Name
Type
Description
crs
String, null

Coordinate Reference System

samplingDistance
Number, null

Sampling distance

projectionMode
mergeParts
Boolean, null

Flag to merge parts

orthoFormat
noDataColor
String, null

No data color

colorSource
dsmFormat
overviews
noDataValue
Number, null

No data value

noDataTransparency
Boolean, null

No data transparency

Options OBJ

Name
Type
Description
textureColorSource
textureColorSourceResMin
Number, null

Minimum resolution for the texture color source

textureColorSourceResMax
Number, null

Maximum resolution for the texture color source

textureColorSourceThermalUnit
textureColorSourceThermalMin
Number, null

Minimum thermal value for the texture color source

textureColorSourceThermalMax
Number, null

Maximum thermal value for the texture color source

crs
String, null

Coordinate Reference System

Options OBJ

Name
Type
Description
textureColorSource
textureColorSourceResMin
Number, null

Minimum resolution for the texture color source

textureColorSourceResMax
Number, null

Maximum resolution for the texture color source

textureColorSourceThermalUnit
textureColorSourceThermalMin
Number, null

Minimum thermal value for the texture color source

textureColorSourceThermalMax
Number, null

Maximum thermal value for the texture color source

maximumTextureSize
Integer, null

Maximum texture size

textureCompression
Integer, null

JPG compression of texture file

textureSharpening
Boolean, null

Enable or disable texture sharpening.

lodScope
lodType
crs
String, null

Coordinate Reference System

crsOrigin

Export

Name
Type
Description
format
name
String, null

Name used for the reality data.

location
String

Reality data id of the export

Production Outputs

Name
Type
Description
exports

List of exports

Production Specifications

Name
Type
Description

Reconstruction Inputs

Name
Type
Description
scene
String

Reality data id of ContextScene to process

regionOfInterest
String, null

Path in the bucket to region of interest file, used for tiling region of interest

extent
String, null

Path in the bucket to region of interest file, used for export extent

modelingReference
String, null

Reality data id of modeling reference to process

crsData
String, null

Path in the bucket for CRS Data

presets
String[], null

List of paths to preset

Reconstruction Outputs

Name
Type
Description
modelingReference
exports
Export[], null

List of exports

Reconstruction Specifications

Name
Type
Description

Constraint Type

Name
Type
Description
Mesh
String
Polygon
String

Constraint To Add

Name
Type
Description
constraintPath
String

Path in the bucket to the constraint file

crs
String

Coordinate Reference System

resolution
Number, null

Resolution of the constraint

texturePath
String, null

Path in the bucket to the texture file

textureSize
Integer, null

Size of the texture

fillColor
String, null

Fill color for the constraint

name
String, null

Name of the constraint

description
String, null

Description of the constraint

Constraints Inputs

Name
Type
Description
modelingReference
String

Reality data id of ContextScene to process

constraintsToDelete
String[], null

IDs of constraints to delete

constraintsToAdd

Constraints to add

crsData
String, null

Path in the bucket for CRS Data

Constraints Outputs

Name
Type
Description
addedConstraintsInfo
String

Path in the bucket for added ConstraintsInfo

Constraints Specifications

Name
Type
Description

TouchUp Export Inputs

Name
Type
Description
modelingReference
String

Reality data id of Modeling Reference

tilesToTouchUp
String[], null

List of tiles to export for touch up

TouchUp Export Outputs

Name
Type
Description
touchUpData
String

Reality Data id for touch up data

Touch Level

Name
Type
Description
Geometry
String
GeometryAndTexture
String

TouchUp Export Options

Name
Type
Description
crs
String, null

Export CRS

TouchUp Export Specifications

TouchUp Import Inputs

Name
Type
Description
modelingReference
String

Reality data id of Modeling Reference

touchUpData
String

Reality Data id for touch up data

TouchUp Import Outputs

Name
Type
Description
importInfo
String, null

Folder in bucket containing the information about what was imported

TouchUp Import Specifications

Name
Type
Description

WaterConstraints Inputs

Name
Type
Description
scene
String

Reality data id of ContextScene

modelingReference
String

Reality data id of Modeling Reference

crsData
String, null

Path in the bucket for CRS Data

WaterConstraints Outputs

Name
Type
Description
constraints
String

Path in the bucket of output constraints

WaterConstraints Options

Name
Type
Description
forceHorizontal
Boolean, null

Force constraints to be horizontal

WaterConstraints Specifications

Gaussian Splats Inputs

Name
Type
Description
scene
String

Reality data id of ContextScene to process

splatsReference
String, null

Reality data ID of the Gaussian Splats Reference.

regionOfInterest
String, null

Path in the bucket to region of interest file

crsData
String, null

Path in the bucket for CRS Data

preset
String, null

Path to preset

Gaussian Splats Outputs

Name
Type
Description
splats
String, null

Reality data ID of Gaussian Splats.

splatsReference
String, null

Reality data ID of Gaussian Splats Reference.

GS Format

Name
Type
Description
SPZ
String
3DTiles
String
PLY
String
3DTilesLOD
String

GSQuality

Name
Type
Description
Medium
String
Standard
String
High
String

Gaussian Splats Options

Name
Type
Description
exportFormat
referenceQuality
referenceTileSize
Number, null

Tile size for the Splats Reference

exportCrs
String, null

CRS for the exported Gaussian Splats

Gaussian Splats Specifications

Job type

Supported job types

Name
Type
Description
FillImageProperties
String
ImportPointCloud
String
Calibration
String
Tiling
String
Production
String
Reconstruction
String
Constraints
String
TouchUpExport
String
TouchUpImport
String
WaterConstraints
String
GaussianSplats
String

Job

Job information

Name
Type
Description
id
String

Job unique id

userId
String

Identifier of the user that created the job.

name
String, null

Job name

iTwinId
String

iTwin Id

FillImageProperties Outputs for Create

Values for outputs for Fill Image Properties job creation.

Name
Type
Description
Scene
String

FillImageProperties Specifications for Create

Specifications for Fill Image Properties job creation.

Name
Type
Description
outputs

List of output type for Fill Image Properties job

ImportPointCloud Outputs Create

Name
Type
Description
ScanCollection
String
Scene
String

ImportPointCloud Specifications Create

Name
Type
Description
outputs

List of outputs for point cloud import

Calibration Outputs Create

Name
Type
Description
Scene
String
Report
String
TexturedTiePoints
String

Calibration Specifications Create

Name
Type
Description
outputs

List of outputs for calibration

Tiling Outputs Create

Name
Type
Description
ModelingReference
String

Tiling Specifications Create

Name
Type
Description

ExportCreate

Name
Type
Description
format
name
String, null

Name used for the reality data.

Production Outputs Create

Name
Type
Description
exports

List of exports

Production Specifications Create

Name
Type
Description

Reconstruction Outputs Create

Name
Type
Description
modelingReference
Boolean, null

Modeling Reference

exports
ExportCreate[], null

Exports

Reconstruction Specifications Create

Constraints Outputs Create

Name
Type
Description
AddedConstraintsInfo
String

Constraints Specifications Create

Name
Type
Description

TouchUp Export Outputs Create

Name
Type
Description
TouchUpData
String

TouchUp Export Specifications Create

Name
Type
Description

TouchUp Import Outputs Create

Name
Type
Description
ImportInfo
String

TouchUp Import Specifications Create

Name
Type
Description

WaterConstraints Outputs Create

Name
Type
Description
Constraints
String

WaterConstraints Specifications Create

Gaussian Splats Outputs Create

Name
Type
Description
Splats
String
SplatsReference
String

Gaussian Splats Specifications Create

Job Creation

Model for creating a new job

Job response

Name
Type
Description
job

Was this page helpful?